<div class="row">
 <div class="col-12 d-flex justify-content-between">
   <a href="/teaching/xml/tp3"class="btn btn-primary" role="button">TP 3</a>
  <a href="/teaching"class="btn btn-primary" role="button" >Sommaire </a>
<a href="/teaching/xml/tp5"class="btn btn-primary" role="button" >TP 5</a> 
 </div>
</div>
<h1><%= title %> </h1>
 <h2>Introduction</h2>
 <hr/>
 <p>Le but de ce tp est d'apprendre à récupérer de l'information dans un
document XML. <p>
	
  <h2>Exercice 1 </h2>
 <hr/> 
        Pour valider un document XML selon un schéma XSD, nous utiliserons le programme <b>xmllint</b> en ligne de commande. 
        <pre><code>xmllint fichier_a_tester.xml --noout --xpath "expression"</code></pre>

    	Récupérér le <a href="https://www.w3schools.com/xml/cd_catalog.xml">document</a>
        Réponder aux questions suivantes avec une expression Xpath:
    <ul>
        <li>Combien d'éléments CD sont présent? (26)</li>
        <li>Quel est le TITLE du second CD (Hide your heart)</li>
        <li>Tous les TITTLE de Joe Cocker?(unchain my heart)</li>
        <li>Le prix du CD de Bob Dylan (10.90)</li>
        <li>La somme des PRICE de tous les CD (237) </li>
        <li>Le TITLE du dernier CD sorti après l'année (YEAR) 1988 ? (Pavarotti Gala Concert). </li>
        <li>Le nom de la COMPANY avant le CD ayant pour TITLE "Black angel".(Atlantic).</li>
        <li>Le nombre des cd qui ne sont pas de la COMPANY 'Polydor'(23).</li>
        <li>Le nombre des cd qui ne sont pas de la COMPANY 'Polydor' ET 
        dont l'année est supérieur à 1995.(4)</li>
    </ul>
 
<h2>Exercice 2 </h2>
 <hr/>
    	Récupérér le <a href="/files/all_civilisations.xml">document</a>
        Réponder aux questions suivantes avec une expression Xpath:
        <ul>
            <li>Combien de civilisations sont présentes ?</li>
            <li>Combien de civilisations sont spécialisées dans le militaire?</li>
            <li>Quelles civilisations à le château le moins chère ? </li>
            <li>Quelle est la somme du coût total d'un Forum ? </li>
            <li>Quelles civilisations possède l'alternance des cultures ? </li>
            <li>Quelles civilisations possède au moins une technologie ayant le terme "barde" dedans ? </li>
            <li>Quelle est l'ATK d'un tirailleur ? </li>
            <li>Combien de PV pour un paladin ? </li>
            <li>Quel  civilisation ne possède pas la technologie architecture ? </li>
            <li>Combien d'unités possède le terme lourd  ? </li>
            <li>Combien coûte une merveille ? </li>
            
            <li>Quel âge minimal nécessaire pour construire un Forum (si le premier à été détruit par un rush...)? </li>
            <li>Quel  est le batiment nécessaire pour construite une bombarde? </li>
            <li>Quel est la porté d'un moine ? </li>
        </ul>
        
        
        Développer une programme python capable de parser un document XML
        Pré requis :
        <ul>
            <li>Python3</li>
            <li>Package python <b>lxml</b> (<a href="https://lxml.de/index.html#documentation">documentation</a>)</li>
        </ul>


        Réponder aux questions suivantes avec une expression Xpath en python:
    <ul>
        <li>Combien d'unitées possèdent les Francs ?</li>
        <li>Combien d'unitées à distance ont les Perses ?</li>
        <li>Combien de civilisations ont la "Tactique Parthes" ?</li>
    </ul>
    
    <p>En python développer une fonction capable d'afficher le nom de toutes les civilisations présentes dans le document XML</p>
    
    <p>En python développer une fonction capable à partir d'un nom de civilisation passé en paramètre et d'une expression Xpath, d'afficher les unitées.</p>

    Un peu de statistique:
    <ul>
        <li>Afficher le coût moyen en bois, en pierre et en or des bâtiments par civilisation</li>
        <li>Afficher le boxplot des pv des unitées en fonction de son type par civilisation</li>  
    </ul>
    
    <!--<div class="alert alert-info">
    La commande passé en argument peut être comprise dans des <b>' '</b>.
    </div>-->
<h2>Exercice 3 </h2>
<hr/>
    <h2>Rappel Javascript</h2>
    Parsing d'une chaîne de caractère:
    <pre><code>const parser = new DOMParser();
const xmlDoc = parser.parseFromString(text_value ,"text/xml");</code></pre>
        <p>Navigation dans un document (<a href="https://www.w3schools.com/jsref/dom_obj_all.asp" >réf</a>)</p>
        <pre><code>xmlDoc.documentElement; // element racine
elem.children;          // enfants de elem
elem.childNodes;        // noeuds enfants de elem
elem.parentElement;     // parent de elem

elem.tagName;           // nom de la balise
elem.length;            // taille
elem.childElementCount; // nb enfants de elem

node.nodeValue;         // valeur textuelle du noeud</code></pre>
    	<p>Evaluation d'une expression xPath (<a href="https://developer.mozilla.org/fr/docs/Web/JavaScript/Introduction_%C3%A0_l_utilisation_de_XPath_avec_JavaScript">prototype</a>) </p>
            
        <pre><code>let result = nodes.iterateNext();
while (result) {
    // faire qq chose
    result.iterateNext();
}</code></pre>
    <p>Sérialisation d'un élément XML</p>
<pre><code>str = new XMLSerializer().serializeToString(elem);</code></pre>
    récupérér le <a href="/files/all_civilisations.xml">document</a>
         Développer une page web (HTML5, JS) capable de charger et parser un document XML, d'executer une requête XPath  et afficher le résultat.
        <h3>Visuel</h3>
        <img src="/images/courses/XML/tpXpath.png" width="570px"/>   

        <h3>Améliorations</h3>
        <div>
            <ul>
                <li>Gestion des erreurs si la source XML est mal formée</li>
                <li>Gestion des résultats vides et des erreurs de syntaxe pour les expressions XPath</li>
                <li>Meilleur affichage (tableau, liste, ...)</li>
            </ul>
        </div>
 
 <div class="row">
 <div class="col-12 d-flex justify-content-between">
   <a href="/teaching/xml/tp3"class="btn btn-primary" role="button">TP 3</a>
   <a href="/teaching"class="btn btn-primary" role="button" >Sommaire</a>
   <a href="/teaching/xml/tp5"class="btn btn-primary" role="button" >TP 5</a> 
 </div>
